
## 2.0.0-beta.0 (2022-05-22)


### ⚠ BREAKING CHANGES

* **container:** Use `container.env.addVariable()` instead of `container.addEnv()`. Property `env` of container renamed to `envVariables`. 

Resolves https://github.com/cdk8s-team/cdk8s-plus/issues/346

Signed-off-by: Eli Polonsky <epolon@amazon.com>
* The interface `Resources` is now named `ContainerResources`.

Signed-off-by: Christopher Rybicki <rybickic@amazon.com>
* **workload:** `defaultSelector` renamed to `select`. `selectByLabel` renamed to `select` and underwent an API change: `deployment.selectByLabel('key', 'value') -> deployment.select(LabelSelector.equals('key', 'value'))`

Fixes https://github.com/cdk8s-team/cdk8s-plus/issues/414
Fixes https://github.com/cdk8s-team/cdk8s-plus/issues/413
* `deployment.expose` renamed to `deployment.exposeViaService`
* `deployment.expose` and `service.addDeployment` now accept a `port` as part of the options, and not a positional argument.

### Features

* `Role`, `ClusterRole`, `RoleBinding`, `ClusterRoleBinding` L2s ([#432](https://github.com/cdk8s-team/cdk8s-plus/issues/432)) ([aeaba6e](https://github.com/cdk8s-team/cdk8s-plus/commit/aeaba6eaa29e2947ba74732448b6bd65b8faacf7)), closes [#24](https://github.com/cdk8s-team/cdk8s-plus/issues/24) [#25](https://github.com/cdk8s-team/cdk8s-plus/issues/25) [#26](https://github.com/cdk8s-team/cdk8s-plus/issues/26) [#374](https://github.com/cdk8s-team/cdk8s-plus/issues/374)
* bump cdk8s to version `2.x` ([#696](https://github.com/cdk8s-team/cdk8s-plus/issues/696)) ([814af13](https://github.com/cdk8s-team/cdk8s-plus/commit/814af13691fc7ba7dd766ad227b39cd34d9c26fa))
* bump minimum node version to 14.x ([#697](https://github.com/cdk8s-team/cdk8s-plus/issues/697)) ([cb1953d](https://github.com/cdk8s-team/cdk8s-plus/commit/cb1953decc8c344fb6abbdf40f4757a8e2f0deb4))
* classes for common secret types ([#473](https://github.com/cdk8s-team/cdk8s-plus/issues/473)) ([716fb13](https://github.com/cdk8s-team/cdk8s-plus/commit/716fb13372c0547ccd93391bbafddf81343fecc5)), closes [#344](https://github.com/cdk8s-team/cdk8s-plus/issues/344)
* **config-map:** immutable maps ([#520](https://github.com/cdk8s-team/cdk8s-plus/issues/520)) ([e95ceb9](https://github.com/cdk8s-team/cdk8s-plus/commit/e95ceb94b6412584d9d2c6ddef5ea5310491f976))
* container lifecycle hooks ([#484](https://github.com/cdk8s-team/cdk8s-plus/issues/484)) ([06fd7d9](https://github.com/cdk8s-team/cdk8s-plus/commit/06fd7d93262001bf286940562f0aacd415eeefb4))
* Container resource requirements and HPA ([#390](https://github.com/cdk8s-team/cdk8s-plus/issues/390)) ([34621b1](https://github.com/cdk8s-team/cdk8s-plus/commit/34621b14a40c8367cd2f2707f6db32464d362f09)), closes [#27](https://github.com/cdk8s-team/cdk8s-plus/issues/27)
* **container:** populate env from `ConfigMap` and `Secret` ([#688](https://github.com/cdk8s-team/cdk8s-plus/issues/688)) ([39ecc47](https://github.com/cdk8s-team/cdk8s-plus/commit/39ecc47558d435b5b7cb735e54d063eedd40cd0d))
* **daemon-set:** introduce L2 ([#504](https://github.com/cdk8s-team/cdk8s-plus/issues/504)) ([fbc9f0a](https://github.com/cdk8s-team/cdk8s-plus/commit/fbc9f0ad4d8318a8d11d47186f7f55c69e0466ba))
* default port when exposing deployment ([#41](https://github.com/cdk8s-team/cdk8s-plus/issues/41)) ([4ff7fa3](https://github.com/cdk8s-team/cdk8s-plus/commit/4ff7fa3c94f0ad52c6baccab7cbdedd969d359d9))
* **deployment:** `minReadySeconds` and `progressDeadlineSeconds` ([#515](https://github.com/cdk8s-team/cdk8s-plus/issues/515)) ([c94b826](https://github.com/cdk8s-team/cdk8s-plus/commit/c94b8268e69da7368790f85c3d395d9849d0a8e5))
* **deployment:** upgrade strategy ([#521](https://github.com/cdk8s-team/cdk8s-plus/issues/521)) ([5dcaced](https://github.com/cdk8s-team/cdk8s-plus/commit/5dcaced3e400dea644b8066a274ff4b3e108255a))
* Env var from fieldRef/resource support ([#263](https://github.com/cdk8s-team/cdk8s-plus/issues/263)) ([650096f](https://github.com/cdk8s-team/cdk8s-plus/commit/650096f765c019abd52c4876d2690d3dd3fb356f))
* expose service via ingress ([#51](https://github.com/cdk8s-team/cdk8s-plus/issues/51)) ([b6bbc0f](https://github.com/cdk8s-team/cdk8s-plus/commit/b6bbc0f307fb0e3337ae403c7dda1854fc866150))
* **ingress:** resource backend ([#687](https://github.com/cdk8s-team/cdk8s-plus/issues/687)) ([f030ecb](https://github.com/cdk8s-team/cdk8s-plus/commit/f030ecbf4566e07bb62135bf04536a5a70a448f2))
* init containers ([#451](https://github.com/cdk8s-team/cdk8s-plus/issues/451)) ([ac8c58d](https://github.com/cdk8s-team/cdk8s-plus/commit/ac8c58de8e7b210f95989d0bea8250f0c775ab08))
* opt out of service accounts auto mounting tokens ([#658](https://github.com/cdk8s-team/cdk8s-plus/issues/658)) ([55aae7a](https://github.com/cdk8s-team/cdk8s-plus/commit/55aae7a9d1d68b1df4eaf157aa24eb83842b5a2b))
* pod host aliases ([#469](https://github.com/cdk8s-team/cdk8s-plus/issues/469)) ([21d4389](https://github.com/cdk8s-team/cdk8s-plus/commit/21d4389b88eed45ab4d173cf9ad436a5df432dd7)), closes [#378](https://github.com/cdk8s-team/cdk8s-plus/issues/378)
* **pod, workload:** scheduling strategy (`affinity`, `tolerations`, `nodeName`) ([#684](https://github.com/cdk8s-team/cdk8s-plus/issues/684)) ([6d02852](https://github.com/cdk8s-team/cdk8s-plus/commit/6d02852aa2c162ed84e585ed50971311e7379691))
* **pod:** docker registry auth ([#516](https://github.com/cdk8s-team/cdk8s-plus/issues/516)) ([a943879](https://github.com/cdk8s-team/cdk8s-plus/commit/a94387916aa91b7c95b4fec04f923cb2193b5af1))
* **pod:** pod dns settings ([#497](https://github.com/cdk8s-team/cdk8s-plus/issues/497)) ([d377378](https://github.com/cdk8s-team/cdk8s-plus/commit/d377378fe315ee4c2700929c06ca8fcca870eeaa))
* pv & pvc ([#483](https://github.com/cdk8s-team/cdk8s-plus/issues/483)) ([da892bc](https://github.com/cdk8s-team/cdk8s-plus/commit/da892bc7ae08531a2b85372c28d8b3163e350bcb))
* **pv:** directly mount to container ([#491](https://github.com/cdk8s-team/cdk8s-plus/issues/491)) ([c7de2d5](https://github.com/cdk8s-team/cdk8s-plus/commit/c7de2d552782601d107ce90669ef4ad6c4b07ec0)), closes [/github.com/cdk8s-team/cdk8s/pull/889#discussion_r836943364](https://github.com/cdk8s-team//github.com/cdk8s-team/cdk8s/pull/889/issues/discussion_r836943364)
* Secret volume support ([#211](https://github.com/cdk8s-team/cdk8s-plus/issues/211)) ([0e17fe8](https://github.com/cdk8s-team/cdk8s-plus/commit/0e17fe861d47174be56287b0bf326ff5ce4473f4)), closes [#34](https://github.com/cdk8s-team/cdk8s-plus/issues/34)
* **secret:** immutable secrets ([#522](https://github.com/cdk8s-team/cdk8s-plus/issues/522)) ([ab16d59](https://github.com/cdk8s-team/cdk8s-plus/commit/ab16d59431dbeb094e12a33f296f6e504d6b10d9))
* security context ([#455](https://github.com/cdk8s-team/cdk8s-plus/issues/455)) ([963e0b6](https://github.com/cdk8s-team/cdk8s-plus/commit/963e0b6643dad0aee0f58b576673b8784ae86c2a))
* stabilize Ingress for cdk8s-plus-22 ([#4](https://github.com/cdk8s-team/cdk8s-plus/issues/4)) ([46e5488](https://github.com/cdk8s-team/cdk8s-plus/commit/46e54887a09d683582c64a66b37fe93568096003))
* **stateful-set:** `minReady` support ([#659](https://github.com/cdk8s-team/cdk8s-plus/issues/659)) ([cb67822](https://github.com/cdk8s-team/cdk8s-plus/commit/cb67822190b4589ee087a4f5181558d7558b6971))
* **stateful-set:** update strategy ([#523](https://github.com/cdk8s-team/cdk8s-plus/issues/523)) ([e47888d](https://github.com/cdk8s-team/cdk8s-plus/commit/e47888d8cb93def41bab170dd001efe5282b7e82))
* TCP socket probes ([#383](https://github.com/cdk8s-team/cdk8s-plus/issues/383)) ([129d39f](https://github.com/cdk8s-team/cdk8s-plus/commit/129d39f54415930682229e393944dafb7d006584)), closes [/kubernetes.io/docs/reference/generated/kubernetes-api/v1.23/#probe-v1](https://github.com/cdk8s-team//kubernetes.io/docs/reference/generated/kubernetes-api/v1.23//issues/probe-v1) [#345](https://github.com/cdk8s-team/cdk8s-plus/issues/345)
* **volume:** azure, gce and aws volumes ([#499](https://github.com/cdk8s-team/cdk8s-plus/issues/499)) ([31dc389](https://github.com/cdk8s-team/cdk8s-plus/commit/31dc38956f47772cf13dbc36f4c0fe1eaab0176f))
* **workload:** expression selectors and pod metadata integration ([#660](https://github.com/cdk8s-team/cdk8s-plus/issues/660)) ([a3d88ac](https://github.com/cdk8s-team/cdk8s-plus/commit/a3d88acbedb66fa81f8b5597ead3e6596604284b))


### Bug Fixes

* branch regex doesn't capture current branch names ([#48](https://github.com/cdk8s-team/cdk8s-plus/issues/48)) ([f75c50d](https://github.com/cdk8s-team/cdk8s-plus/commit/f75c50d44666be0084740df5cbb288583d674ba7))
* callable import incompatible with esModuleInterop ([#80](https://github.com/cdk8s-team/cdk8s-plus/issues/80)) ([e4a2c0f](https://github.com/cdk8s-team/cdk8s-plus/commit/e4a2c0fd8134b16bf340e34b28e11a4ef86980d3))
* **deployment:** unable to set `maxUnavailable` on a rolling update strategy ([#724](https://github.com/cdk8s-team/cdk8s-plus/issues/724)) ([2c40476](https://github.com/cdk8s-team/cdk8s-plus/commit/2c40476e12a9f890504c7ea7b865e9d04fcd06d8))
* release branch workflow ([#6](https://github.com/cdk8s-team/cdk8s-plus/issues/6)) ([78f5fcb](https://github.com/cdk8s-team/cdk8s-plus/commit/78f5fcb8cf5b9ef5e6661a28610412c048acd11c))
